
$(function(){
	var timer_id = null;
	chrome.extension.onRequest.addListener(function(request, send, sendResponse){
		switch(request.command){
			case "collect_mission_list":
				var ids = [];
				$(".tm_list_element[data-mid]").each(function(idx, e){
					var mid = $(e).attr("data-mid");
					if (mid) ids.push(mid);
				});
				sendResponse(ids);
				break;

			case "modify_mission_list":
				var update_mission = function(){
					for(var i in request.exists)
						$(".tm_list_element[data-mid='"+i+"']").addClass(request.exists[i]);
					$(".mission_not_exists_count").remove();
					if (request.not_exists_count > 0)
						$("<span></span>").text(request.not_exists_count).addClass("mission_not_exists_count").appendTo("#tm_header_title");
				};
				if (timer_id) clearInterval(timer_id);
				$(".tm_list_element[data-mid]").removeClass("imm_nothing");
				update_mission();
				timer_id = setInterval(update_mission, 500);
				sendResponse();
				break;

			default:
				sendResponse();
				break;
		}
	});

});

