
chrome.devtools.network.onRequestFinished.addListener(function(request){
	if (!/(getTopMissionsInBounds|getMissionDetails)$/.test(request.request.url)) return;
	var url = request.request.url.match(/\/(getTopMissionsInBounds|getMissionDetails)$/);
	if (!url) return;
	request.getContent(function(content){
		if (!content) return;
		var json = JSON.parse(content);
		if (!json) return;
		json.url = url[1];
		chrome.extension.sendRequest(json);
	});
});

